int boutonRecPin = 3;
int boutonReplayPin = 4;
int pot1Pin = A0;
int pot2Pin = A1;
int pot3Pin = A2;

int boutonRecPrevious = 0;
int boutonReplayPrevious = 0;
int pot1Previous = 0;
int pot2Previous = 0;
int pot3Previous = 0;

long resetTimer = 0;

void setup() {
  Serial.begin(57600);
  pinMode(boutonRecPin, INPUT);
  pinMode(boutonReplayPin, INPUT);
  Serial.println("reset");
}

void loop() {
  int boutonRecValue = digitalRead(boutonRecPin);
  if (boutonRecValue == HIGH && boutonRecPrevious == LOW ){ Serial.println("rec");}
  if (boutonRecValue == LOW && boutonRecPrevious == HIGH ){ Serial.println("stoprec");}
  boutonRecPrevious = boutonRecValue;
  
  int boutonReplayValue = digitalRead(boutonReplayPin);
  if (boutonReplayValue == HIGH && boutonReplayPrevious == LOW ){ Serial.println("replay"); resetTimer = millis(); delay(200);}
  if (boutonReplayValue == LOW && boutonReplayPrevious == HIGH ){ resetTimer = 0;}
  boutonReplayPrevious = boutonReplayValue;

  int pot1Value = analogRead(pot1Pin);
  if (pot1Value < pot1Previous - 1 || pot1Value > pot1Previous + 1) {
    Serial.print("pot1 ");
    Serial.println(pot1Value);
  }
  pot1Previous = pot1Value;

  int pot2Value = analogRead(pot2Pin);
  if (pot2Value < pot2Previous - 1 || pot2Value > pot2Previous + 1) {
    Serial.print("pot2 ");
    Serial.println(pot2Value);
  }
  pot2Previous = pot2Value;

  int pot3Value = analogRead(pot3Pin);
  if (pot3Value < pot3Previous - 1 || pot3Value > pot3Previous + 1) {
    Serial.print("pot3 ");
    Serial.println(pot3Value);
  }
  pot3Previous = pot3Value;

  // envoie le reset quand les trois potards sont <5% et que le bouton replay est maintenu enfoncé 5s
  if( pot1Value < 50 && pot2Value < 50 && pot3Value < 50 && resetTimer > 0 && millis() > resetTimer + 5000){
    Serial.println("reset");
    resetTimer=0;
    } 
}
